<template>
    <div>
        <div v-if="invalid">
            <div class="alert alert-danger text-center" role="alert">
                Current password is not valid.
            </div>
        </div>
        <div v-if="changed">
            <div class="alert alert-success text-center" role="alert">
                Password changed successfully.
            </div>
        </div>
        <form @submit.prevent="onSubmit">
            <div class="form-group">
                <label for="currentPassword">Current Password</label>
                <input type="password"
                       id="currentPassword"
                       class="form-control"
                       v-model="currentPassword"
                       :class="{'is-invalid': $v.currentPassword.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.currentPassword.required">
                            Please enter your current password.
                        </span>
                </span>
            </div>
            <div class="form-group">
                <label for="newPassword">New Password</label>
                <input type="password"
                       id="newPassword"
                       class="form-control"
                       v-model="newPassword"
                       :class="{'is-invalid': $v.newPassword.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.newPassword.required">
                            Please enter the new password.
                        </span>
                </span>
            </div>
            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px">
                Confirm
            </button>
        </form>
    </div>
</template>

<script>
    import {required} from "vuelidate/lib/validators";
    import UserService from "../../services/user.service";

    export default {
        data() {
            return {
                currentPassword: '',
                newPassword: '',
                invalid: false,
                changed: false
            }
        },
        validations: {
            currentPassword: {
                required
            },
            newPassword: {
                required
            }
        },
        methods: {
            onSubmit() {
                this.$v.$touch();
                const formData = {
                    currentPassword: this.currentPassword,
                    newPassword: this.newPassword
                };
                UserService.changePassword(formData).subscribe(res => {
                    this.$store.dispatch('login', {token: res.data.token, username: this.username});
                    this.currentPassword = '';
                    this.newPassword = '';
                    this.$v.$reset();
                    this.changed = true;
                }, error => {
                    console.log(error);
                    this.invalid = true;
                })
            }
        },
        computed: {
            username() {
                return this.$store.getters.username;
            }
        }
    }
</script>
